// day of week of month's first day
function getFirstDay(theYear, theMonth){
    var firstDate = new Date(theYear,theMonth,1);
    return firstDate.getDay();
}
// number of days in the month
function getMonthLen(theYear, theMonth) {
    var nextMonth = new Date(theYear, theMonth + 1, 1);
    nextMonth.setHours(nextMonth.getHours() - 3);
    return nextMonth.getDate();
}

// clear and re-populate table based on form's selections
function populateTable(form) {
    // pick up date form choices
    var theMonth = form.chooseMonth.selectedIndex;
    var theYear = parseInt(form.chooseYear.options[form.chooseYear.selectedIndex].text);
    // initialize date-dependent variables
    var firstDay = getFirstDay(theYear, theMonth);
    var howMany = getMonthLen(theYear, theMonth);
    var today = new Date();
    
    // fill in month/year in table header
    document.getElementById("tableHeader").innerHTML =
        form.chooseMonth.options[theMonth].text + " " + theYear;

    // initialize vars for table creation
    var dayCounter = 1;
    var TBody = document.getElementById("tableBody");
    // clear any existing rows
    while (TBody.rows.length > 0) {
        TBody.deleteRow(0);
    }
    var newR, newC, dateNum;
    var done=false;
    while (!done) {
        // create new row at end
        newR = TBody.insertRow(TBody.rows.length);
        if (newR) {
            for (var i = 0; i < 7; i++) {
                // create new cell at end of row
                newC = newR.insertCell(newR.cells.length);
                if (TBody.rows.length == 1 && i < firstDay) {
                    // empty boxes before first day
                    newC.innerHTML = "&nbsp;";
		    newC.className = 'other-cal';
                    continue;
                }
                if (dayCounter == howMany) {
                    // no more rows after this one
                    done = true;
                }
                // plug in link/date (or empty for boxes after last day)
                if (dayCounter <= howMany) {
                    if (today.getFullYear() == theYear &&
                        today.getMonth() == form.chooseMonth.selectedIndex &&
                        today.getDate() == dayCounter) {
                        newC.id = "today";
			newC.className = 'current-cal';
                    } else {
			newC.className = 'alt-cal';
		    }
                    newC.innerHTML = "<a href=\"#\" class=\"cal-choose-date\" data-day=\"" + dayCounter + "\" data-month=\"" + theMonth + "\" data-year=\"" + theYear + "\">" + dayCounter + "</a>";
                    dayCounter++;
               } else {
                    newC.innerHTML = "&nbsp;";
		    newC.className = 'other-cal';
                }
            }
        } else {
            done = true;
        }
    }
    setCalEvents();
}

function chooseDate(date, month, year) {
	month = parseInt(month) + 1;
	if(month < 10)
		month = '0' + month;
	if(date < 10)
		date = '0' + date; 
	var txt = self.opener.document.getElementById('~get_filenamevar(4)');
	if ( txt )
		txt.innerHTML = '(' + date+ '/' + month + '/' + year +')';

	~if(~get_filenamevar(3)==14,"
		var time = '~format_unixtimestamp('%H%M%S',~time())';
		var hour = document.getElementById('calendar-hour');
		var minute = document.getElementById('calendar-minute');
		if ( hour && minute ) {
			time = '';//hour.form.chooseHour.selectedIndex.toString();
			if(hour.form.chooseHour.selectedIndex<10)
				time = '0';
			time += hour.form.chooseHour.selectedIndex.toString();
			time += minute.form.chooseMinute.options[minute.form.chooseMinute.selectedIndex].text;
			time += '00';
		}	
		fillForm('~get_filenamevar(1)','~get_filenamevar(2)', year + '' + month + '' + date + '' + time);
	","
		fillForm('~get_filenamevar(1)','~get_filenamevar(2)', year + '' + month + '' + date);
	")
}

function scrollCalendar(year_offset, month_offset)
{
    var form = document.getElementById('calendar-form');
    var theMonth = form.chooseMonth.selectedIndex;
    var theYear = form.chooseYear.selectedIndex;
    if( theMonth == 11 && month_offset == 1) {
	theMonth = 0;
	theYear += 1;
    } else if ( theMonth == 0 && month_offset == -1) {
	theMonth = 0;
	theYear -= 1;
    } else {
	theMonth += month_offset;
	theYear += year_offset;
    }
    form.chooseMonth.selectedIndex = theMonth;
    form.chooseYear.selectedIndex = theYear;
    populateTable(form);
}

function startChooser()
{
    form = document.dateChooser;
    populateTable(form);
    var select_month = document.getElementById('calendar-month');
    select_month.onchange = function(e) {
	populateTable(e.currentTarget.form);
    }
    var select_year = document.getElementById('calendar-year');
    select_year.onchange = function(e) {
	populateTable(e.currentTarget.form);
    }
    var prevyear = document.getElementById('calendar-prevyear');
    prevyear.onclick = function(e) {
	scrollCalendar(-1,0);
    }
    var nextyear = document.getElementById('calendar-nextyear');
    nextyear.onclick = function(e) {
	scrollCalendar(1,0);
    }
    var prevmonth = document.getElementById('calendar-prevmonth');
    prevmonth.onclick = function(e) {
	scrollCalendar(0,-1);
    }
    var nextmonth = document.getElementById('calendar-nextmonth');
    nextmonth.onclick = function(e) {
	scrollCalendar(0,1);
    }
}

function setCalEvents()
{
    var choosedates = document.getElementsByClassName('cal-choose-date');
    for( var i=0, len=choosedates.length; i<len; i=i+1) {
		var id = choosedates[i];
		id.onclick = function(e) {
			if( e.currentTarget.getAttribute('data-day') ) {
				var day = e.currentTarget.getAttribute('data-day');
				var year = e.currentTarget.getAttribute('data-year');
				var month = e.currentTarget.getAttribute('data-month');
				chooseDate(day, month, year);
				e.preventDefault();
			}
		};
	}
}

if (document.readyState === 'loading') {  // Loading hasn't finished yet
  document.addEventListener('DOMContentLoaded', startChooser);
} else {  // `DOMContentLoaded` has already fired
  startChooser();
}
