~defunc('e',~htmlspecialchars(~sparam(1)))
function cleanAutoLink( prefix, button) {
	var elm=document.getElementById(prefix);
	var bbimg=document.getElementById('bb-' + prefix + '-img');
	var bbanc = document.getElementById('bb-' + prefix + '-anc');
	if ( bbimg && bbanc && elm ) { 
		if (button.checked == true ) {
			var ok;
			ok = window.confirm('Les balises liens et images actuelles seront effacées !');
			if( ok ) {
				bbimg.style.display='none';
				bbanc.style.display='none';
				document.getElementById('bbinput-' + prefix).innerHTML='';
				clearLink(elm);
			 } else {
			 	button.checked = false;
			}
		} else {
			bbimg.style.display='inline';
			bbanc.style.display='inline';
		}
	}
}
function clearLink(txt) {
	var anc = new RegExp('<a href="([^"]+)"[^>]*>([^<]+)</a>','g');	
	var img = new RegExp('<img src="([^"]+)"[^>]*/>','g');
	txt.value = txt.value.replace(anc, '$1');//drop $2...
	txt.value = txt.value.replace(img, '$1');
}
function cleanQuote(txt) {
	var quot = new RegExp('"','g');	
	txt = txt.replace(quot, '');
	return txt;
}
function styleTag(tag, id) {
	var tagOpen = '<' + tag + '>';
	var tagClose = '</' + tag + '>';
	styleInsertTag(tagOpen, tagClose, id, 0);
}
function insertForm(id, what) {
	styleInsertTag(what, '', id, 0);
}
function styleInsertTag(tagOpen, tagClose, id, insert_only) {
	var ta;
	if ( document.getElementById ) 
		ta = document.getElementById(id);
	if (! ta )
		return;
	var selLength = ta.textLength;
	var selStart = ta.selectionStart;
	var selEnd = ta.selectionEnd;
	if (selEnd == 1 || selEnd == 2) {
		selEnd = selLength;
	}
	var s1 = (ta.value).substring(0, selStart);
	var s2 = (ta.value).substring(selStart, selEnd)
	var s3 = (ta.value).substring(selEnd, selLength);
	if ( insert_only == 0 ) {
		ta.value = s1 + tagOpen + s2 + tagClose + s3;
	} else {
		ta.value = s1 + tagOpen + tagClose + s2 + s3;
	}
	ta.focus();
	var pos = selEnd+tagOpen.length+tagClose.length;
	ta.setSelectionRange( pos, pos);
	return;
}
function toggleId(id) {
	var node;
	if ( document.getElementById ) {
		node = document.getElementById(id);
	}
	if ( node ) {
		if ( node.style.display == 'block' ) {
			node.style.display = 'none';
		} else {
			node.style.display = 'block';
		}
	}
}
function toggleListId(id) {
	var node;
	if ( document.getElementById ) {
		node = document.getElementById(id);
	}
	if ( node ) {
		//console.log(node.style.display);
		if ( node.style.display == 'none' ) {
			node.style.display = 'inline';
		} else {
			node.style.display = 'none';
		}
	}
}

function escape_tag(tag, help, render)
{
	if(render)
		str = '&lt;' + tag + '&gt;<' + tag + '>' + help + '</' + tag + '>&lt;/' + tag + '&gt;';
	else
		str = '&lt;' + tag + '&gt;' + help + '&lt;/' + tag + '&gt;';
	return str;
}
var tags = [ 'b', 'i', 'u', 's', 'mark', 'sup', 'sub', 'cite', 'site', 'article', 'rubrique', 'magazine'];
var help_text = [ 'Affiche le texte sélectionné en gras. Ex: ',
		'Met en italique le texte sélectionné. Ex: ',
		'Souligne le texte sélectionné. Ex: ',
		'Barre le texte sélectionné. Ex: ',
		'Surligne le texte sélectionné. Ex: ',
		'Place en exposant le texte sélectionné. Ex: ',
		'Place en indice le texte sélectionné. Ex: ',
		'Met en relief les citations, en ajoutant une indentation et en modifiant la couleur de fond. Ex: ',
		'Met en lien un site web externe. Ex: ',
		'Crée un lien interne vers un article. Ex: ',
		'Crée un lien interne vers une rubrique. Ex: ',
		'Crée un lien interne vers un magazine. Ex: ',
		];
var help = [ 'Texte en gras', 'Texte en italique', 'Texte souligné', 'Texte barré', 'Texte surligné', 'Exposant', 'Indice', 'Citation', 'Website', 'Article', 'Rubrique', 'Magazine'];
var render = [ true, true, true, true, true, true, true, true, false, false, false, false];
function bbSetup()
{
	var divs = document.getElementsByClassName('bbcode');
	for( var i=0, len=divs.length; i<len; i=i+1) {
		var id = divs[i].id;
		var elem = document.getElementById(id);
		var edit_id = elem.getAttribute('data-edit-id');

		let textArea = document.getElementById(edit_id);
		let characterCounter = document.getElementById("bb-"+edit_id+"-ccounter");

		const countCharacters = () => {
			var txt = textArea.value;
			let strippedString = txt.replace(/(<([^>]+)>)/gi, "");
			let counter = strippedString.length;
			characterCounter.textContent = (counter).toString() + " caractère" + ((counter>1)? "s":"") + " ";
		};
		textArea.addEventListener("input", countCharacters);
		countCharacters();
		
		for( var j=0; j < tags.length; j=j+1) {
			var el_id = 'bb-'+edit_id+'-' + tags[j];
			var tag_elem = document.getElementById(el_id);
			if( tag_elem ) {
				tag_elem.myEditId = edit_id;
				tag_elem.myTag = tags[j];
				tag_elem.myTTT = help[j];
				tag_elem.myHelpTxt = help_text[j];
				tag_elem.myRender = render[j];
				tag_elem.onmouseover = function(e) {
					if( e.currentTarget.myEditId )
						document.getElementById('bbhelp'+e.currentTarget.myEditId).innerHTML = e.currentTarget.myHelpTxt + escape_tag(e.currentTarget.myTag, e.currentTarget.myTTT, e.currentTarget.myRender);
				 };
				tag_elem.onclick = function(e) {
					if( e.currentTarget.myEditId )
						styleTag(e.currentTarget.myTag, e.currentTarget.myEditId);
				};
			}
		}
		var ch_el = document.getElementById('bb-'+edit_id+'-char');
		if(ch_el) {
			ch_el.myEditId = edit_id;
			ch_el.onmouseover = function(e) {
				if( e.currentTarget.myEditId )
					document.getElementById('bbhelp'+e.currentTarget.myEditId).innerHTML = 'Affiche la table de caractères';
			};
			ch_el.onclick = function(e) {
				if( e.currentTarget.myEditId )
					toggleId('charmap-'+e.currentTarget.myEditId);
			};
		}
		var cm = document.getElementById('charmap-'+edit_id);
		if(cm) {
			var as = cm.getElementsByTagName('a');
			for(let j=0; j < as.length; j++) {
				var cm_el = as[j];
				if( cm_el) {
					cm_el.myEditId = edit_id;
					cm_el.onclick = function(e) {
						if( e.currentTarget.myEditId ) {
							insertForm(e.currentTarget.myEditId, e.currentTarget.innerHTML);
							e.preventDefault();
						}
					};
				}
			}
		}
		var tag_art = document.getElementById('bb-'+edit_id+'-article-wiz');
		if(tag_art) {
			tag_art.myEditId = edit_id;
			tag_art.onclick = function(e) {
				if( e.currentTarget.myEditId)
					toggleId('bb-'+e.currentTarget.myEditId+'-div-article');
			};
			tag_art.onmouseover = function(e) {
				if( e.currentTarget.myEditId )
					document.getElementById('bbhelp'+e.currentTarget.myEditId).innerHTML = "~e('<article rubrique="Rubrique">Titre de l\'article</article>')";
			};
		}
		var add_art = document.getElementById('bb-'+edit_id+'-add-article');
		if(add_art) {
			add_art.myEditId = edit_id;
			add_art.onclick = function(e) {
				if( e.currentTarget.myEditId ) {
					edit_id = e.currentTarget.myEditId;
					styleInsertTag( '<article rubrique="' 
						+ cleanQuote(document.getElementById('bb-' + edit_id + '-art-topic').value)
						+ '">'
						+ document.getElementById('bb-' + edit_id+'-art-title').value
						+ '</article>'
						, '', edit_id, 1);
					document.getElementById('bbinput-' + edit_id).innerHTML=''; 
					document.getElementById('bb-' + edit_id + '-art-topic').value='';
					document.getElementById('bb-' + edit_id+'-art-title').value='';
					toggleId('bb-'+edit_id+'-div-article');
				}
			};
		}
		var cancel_art = document.getElementById('bb-'+edit_id+'-cancel-article');
		if(cancel_art) {
			cancel_art.myEditId = edit_id;
			cancel_art.onclick = function(e) {
				if( e.currentTarget.myEditId ) {
					edit_id = e.currentTarget.myEditId;
					document.getElementById('bbinput-' + e.currentTarget.myEditId).innerHTML=''; 
					document.getElementById('bb-' + edit_id + '-art-topic').value='';
					document.getElementById('bb-' + edit_id+'-art-title').value='';
					toggleId('bb-'+edit_id+'-div-article');
				}
			};
		}
		var tag_topic = document.getElementById('bb-'+edit_id+'-rubrique-wiz');
		if(tag_topic) {
			tag_topic.myEditId = edit_id;
			tag_topic.onclick = function(e) {
				if( e.currentTarget.myEditId)
					toggleId('bb-'+e.currentTarget.myEditId+'-div-topic');
			};
			tag_topic.onmouseover = function(e) {
				if( e.currentTarget.myEditId )
					document.getElementById('bbhelp'+e.currentTarget.myEditId).innerHTML = "~e('<rubrique>Nom de la rubrique</rubrique>')";
			};
		}
		var add_topic = document.getElementById('bb-'+edit_id+'-add-topic');
		if(add_topic) {
			add_topic.myEditId = edit_id;
			add_topic.onclick = function(e) {
				if( e.currentTarget.myEditId ) {
					edit_id = e.currentTarget.myEditId;
					styleInsertTag( '<rubrique>' 
						+ document.getElementById('bb-' + edit_id + '-topic-title').value
						+ '</rubrique>'
						, '', edit_id, 1);
					document.getElementById('bbinput-' + edit_id).innerHTML=''; 
					document.getElementById('bb-' + edit_id + '-topic-title').value='';
					toggleId('bb-'+edit_id+'-div-topic');
				}
			};
		}
		var cancel_topic = document.getElementById('bb-'+edit_id+'-cancel-topic');
		if(cancel_topic) {
			cancel_topic.myEditId = edit_id;
			cancel_topic.onclick = function(e) {
				if( e.currentTarget.myEditId ) {
					edit_id = e.currentTarget.myEditId;
					document.getElementById('bbinput-' + e.currentTarget.myEditId).innerHTML=''; 
					document.getElementById('bb-' + edit_id+'-topic-title').value='';
					toggleId('bb-'+edit_id+'-div-topic');
				}
			};
		}
		var tag_email = document.getElementById('bb-'+edit_id+'-email');
		if(tag_email) {
			tag_email.myEditId = edit_id;
			tag_email.onclick = function(e) {
				if( e.currentTarget.myEditId)
					toggleId('bb-'+e.currentTarget.myEditId+'-div-email');
			};
			tag_email.onmouseover = function(e) {
				if( e.currentTarget.myEditId )
					document.getElementById('bbhelp'+e.currentTarget.myEditId).innerHTML = "~e('<a href="mailto:">lien e-mail</a>')";
			};
		}
		var add_email = document.getElementById('bb-'+edit_id+'-add-email');
		if(add_email) {
			add_email.myEditId = edit_id;
			add_email.onclick = function(e) {
				if( e.currentTarget.myEditId ) {
					edit_id = e.currentTarget.myEditId;
					styleInsertTag( '<a href="mailto:' 
						+ document.getElementById('bb-' + edit_id + '-email-title').value
						+ '">'
						+ document.getElementById('bb-' + edit_id + '-email-title').value
						+ '</a>'
						, '', edit_id, 1);
					document.getElementById('bbinput-' + edit_id).innerHTML=''; 
					document.getElementById('bb-' + edit_id + '-email-title').value='';
					toggleId('bb-'+edit_id+'-div-email');
				}
			};
		}
		var cancel_email = document.getElementById('bb-'+edit_id+'-cancel-email');
		if(cancel_email) {
			cancel_email.myEditId = edit_id;
			cancel_email.onclick = function(e) {
				if( e.currentTarget.myEditId ) {
					edit_id = e.currentTarget.myEditId;
					document.getElementById('bbinput-' + e.currentTarget.myEditId).innerHTML=''; 
					document.getElementById('bb-' + edit_id+'-email-title').value='';
					toggleId('bb-'+edit_id+'-div-email');
				}
			};
		}
		var tag_img = document.getElementById('bb-'+edit_id+'-img');
		if(tag_img) {
			tag_img.myEditId = edit_id;
			tag_img.onclick = function(e) {
				if( e.currentTarget.myEditId)
					toggleId('bb-'+e.currentTarget.myEditId+'-div-img');
			};
			tag_img.onmouseover = function(e) {
				if( e.currentTarget.myEditId )
					document.getElementById('bbhelp'+e.currentTarget.myEditId).innerHTML = "~e('<img src="adresse" />')";
			};
		}
		var add_img = document.getElementById('bb-'+edit_id+'-add-img');
		if(add_img) {
			add_img.myEditId = edit_id;
			add_img.onclick = function(e) {
				if( e.currentTarget.myEditId ) {
					edit_id = e.currentTarget.myEditId;
					styleInsertTag( '<img src="' 
						+ cleanQuote(document.getElementById('bb-' + edit_id + '-img-src').value)
						+ '" alt="'
						+ cleanQuote(document.getElementById('bb-' + edit_id + '-img-alt').value)
						+ '" class="'
						+ cleanQuote(document.getElementById('bb-' + edit_id + '-img-align').value)
						+ '" />'
						, '', edit_id, 1);
					document.getElementById('bbinput-' + edit_id).innerHTML=''; 
					document.getElementById('bb-' + edit_id + '-img-src').value='';
					document.getElementById('bb-' + edit_id + '-img-alt').value='';
					toggleId('bb-'+edit_id+'-div-img');
				}
			};
		}
		var cancel_img = document.getElementById('bb-'+edit_id+'-cancel-img');
		if(cancel_img) {
			cancel_img.myEditId = edit_id;
			cancel_img.onclick = function(e) {
				if( e.currentTarget.myEditId ) {
					edit_id = e.currentTarget.myEditId;
					document.getElementById('bbinput-' + e.currentTarget.myEditId).innerHTML=''; 
					document.getElementById('bb-' + edit_id+'-img-src').value='';
					document.getElementById('bb-' + edit_id+'-img-alt').value='';
					toggleId('bb-'+edit_id+'-div-img');
				}
			};
		}
		var tag_anc = document.getElementById('bb-'+edit_id+'-anc');
		if(tag_anc) {
			tag_anc.myEditId = edit_id;
			tag_anc.onclick = function(e) {
				if( e.currentTarget.myEditId)
					toggleId('bb-'+e.currentTarget.myEditId+'-div-anc');
			};
			tag_anc.onmouseover = function(e) {
				if( e.currentTarget.myEditId )
					document.getElementById('bbhelp'+e.currentTarget.myEditId).innerHTML = "~e('<a href="adresse">Titre</a>')";
			};
		}
		var add_anc = document.getElementById('bb-'+edit_id+'-add-anc');
		if(add_anc) {
			add_anc.myEditId = edit_id;
			add_anc.onclick = function(e) {
				if( e.currentTarget.myEditId ) {
					edit_id = e.currentTarget.myEditId;
					styleInsertTag( '<a href="' 
						+ cleanQuote(document.getElementById('bb-' + edit_id + '-anc-href').value)
						+ '">'
						+ document.getElementById('bb-' + edit_id + '-anc-title').value
						+ '</a>'
						, '', edit_id, 1);
					document.getElementById('bbinput-' + edit_id).innerHTML=''; 
					document.getElementById('bb-' + edit_id + '-anc-href').value='';
					document.getElementById('bb-' + edit_id + '-anc-title').value='';
					toggleId('bb-'+edit_id+'-div-anc');
				}
			};
		}
		var cancel_anc = document.getElementById('bb-'+edit_id+'-cancel-anc');
		if(cancel_anc) {
			cancel_anc.myEditId = edit_id;
			cancel_anc.onclick = function(e) {
				if( e.currentTarget.myEditId ) {
					edit_id = e.currentTarget.myEditId;
					document.getElementById('bbinput-' + e.currentTarget.myEditId).innerHTML=''; 
					document.getElementById('bb-' + edit_id+'-anc-href').value='';
					document.getElementById('bb-' + edit_id+'-anc-title').value='';
					toggleId('bb-'+edit_id+'-div-anc');
				}
			};
		}
		var tag_case0 = document.getElementById('bb-'+edit_id+'-case0');
		var tag_case1 = document.getElementById('bb-'+edit_id+'-case1');
		if(tag_case0) {
			tag_case0.myEditId = edit_id;
			tag_case0.onclick = function(e) {
				if( e.currentTarget.myEditId) {
					toggleListId('bb-'+e.currentTarget.myEditId+'-case0');
					toggleListId('bb-'+e.currentTarget.myEditId+'-case1');
					firstToUpper(document.getElementById(e.currentTarget.myEditId), true);
				}
			};
			tag_case0.onmouseover = function(e) {
				if( e.currentTarget.myEditId )
					document.getElementById('bbhelp'+e.currentTarget.myEditId).innerHTML = "Majuscules Titre Automatique";
			};
		}
		if(tag_case1) {
			toggleListId('bb-'+edit_id+'-case1');
			tag_case1.myEditId = edit_id;
			tag_case1.onclick = function(e) {
				if( e.currentTarget.myEditId) {
					toggleListId('bb-'+e.currentTarget.myEditId+'-case0');
					toggleListId('bb-'+e.currentTarget.myEditId+'-case1');
					firstToUpper(document.getElementById(e.currentTarget.myEditId), false);
				}
			};
			tag_case1.onmouseover = function(e) {
				if( e.currentTarget.myEditId )
					document.getElementById('bbhelp'+e.currentTarget.myEditId).innerHTML = "Majuscules Titre Automatique";
			};
		}

		var tag_wandtxt = document.getElementById('bb-'+edit_id+'-wand-text');
		if(tag_wandtxt) {
			tag_wandtxt.myEditId = edit_id;
			tag_wandtxt.onclick = function(e) {
				if( e.currentTarget.myEditId)
					cleanText(document.getElementById(e.currentTarget.myEditId));
			};
			tag_wandtxt.onmouseover = function(e) {
				if( e.currentTarget.myEditId )
					document.getElementById('bbhelp'+e.currentTarget.myEditId).innerHTML = "Fait le ménage dans le texte";
			};
		}

		var tag_wand = document.getElementById('bb-'+edit_id+'-wand');
		if(tag_wand) {
			tag_wand.myEditId = edit_id;
			tag_wand.onclick = function(e) {
				if( e.currentTarget.myEditId)
					cleanTracklist(document.getElementById(e.currentTarget.myEditId));
			};
			tag_wand.onmouseover = function(e) {
				if( e.currentTarget.myEditId )
					document.getElementById('bbhelp'+e.currentTarget.myEditId).innerHTML = "Fait le ménage dans la tracklist";
			};
		}
		var tag_autolink = document.getElementById('bb-autolink-'+edit_id);
		if(tag_autolink) {
			tag_autolink.myEditId = edit_id;
			tag_autolink.onchange = function(e) {
				if( e.currentTarget.myEditId )
					cleanAutoLink(e.currentTarget.myEditId, e.currentTarget);
			};
		}
	}
}

if (document.readyState === 'loading') {  // Loading hasn't finished yet
  document.addEventListener('DOMContentLoaded', bbSetup);
} else {  // `DOMContentLoaded` has already fired
  bbSetup();
}
