~noeval('https://www.w3schools.com/howto/howto_js_password_validation.asp')
function passwd_checker()
{
	var myInput = document.getElementById("pw-password");
	var letter = document.getElementById("pw-letter");
	var number = document.getElementById("pw-number");
	var length = document.getElementById("pw-length");

	document.getElementById("pw-letter-valid").style.display = "none";
	document.getElementById("pw-number-valid").style.display = "none";
	document.getElementById("pw-length-valid").style.display = "none";
	// When the user clicks on the password field, show the message box
	myInput.onfocus = function() {
	  //document.getElementById("pw-message").style.display = "block";
	  document.getElementById("pw-message").style.height = "auto";
	  document.getElementById("pw-message").style.opacity = 1;
	}

	// When the user clicks outside of the password field, hide the message box
	myInput.onblur = function(e) {
	  //document.getElementById("pw-message").style.display = "none";
	  document.getElementById("pw-message").style.height = 0;
	  document.getElementById("pw-message").style.opacity = 0;
	  e.relatedTarget.click();
	}

	// When the user starts to type something inside the password field
	myInput.onkeyup = function() {
	  // Validate lowercase letters
	  var lowerCaseLetters = /[a-z]/g;
	  var upperCaseLetters = /[A-Z]/g;
	  if(myInput.value.match(lowerCaseLetters) && myInput.value.match(upperCaseLetters)) {
	    letter.classList.remove("pw-invalid");
	    letter.classList.add("pw-valid");
	    document.getElementById("pw-letter-invalid").style.display = "none";
	    document.getElementById("pw-letter-valid").style.display = "inline";
	  } else {
	    letter.classList.remove("pw-valid");
	    letter.classList.add("pw-invalid");
	    document.getElementById("pw-letter-valid").style.display = "none";
	    document.getElementById("pw-letter-invalid").style.display = "inline";
	  }
	
	  // Validate numbers
	  var numbers = /[0-9]/g;
	  var special = /[^a-zA-Z0-9]/g;
	  if(myInput.value.match(numbers) || myInput.value.match(special)) {
	    number.classList.remove("pw-invalid");
	    number.classList.add("pw-valid");
	    document.getElementById("pw-number-invalid").style.display = "none";
	    document.getElementById("pw-number-valid").style.display = "inline";
	  } else {
	    number.classList.remove("pw-valid");
	    number.classList.add("pw-invalid");
	    document.getElementById("pw-number-valid").style.display = "none";
	    document.getElementById("pw-number-invalid").style.display = "inline";
	  }
	
	  // Validate length
	  if(myInput.value.length >= 8 && myInput.value.length <= 64) {
	    length.classList.remove("pw-invalid");
	    length.classList.add("pw-valid");
	    document.getElementById("pw-length-invalid").style.display = "none";
	    document.getElementById("pw-length-valid").style.display = "inline";
	  } else {
	    length.classList.remove("pw-valid");
	    length.classList.add("pw-invalid");
	    document.getElementById("pw-length-valid").style.display = "none";
	    document.getElementById("pw-length-invalid").style.display = "inline";
	  }
	}
}

if (document.readyState === 'loading') {  // Loading hasn't finished yet
  document.addEventListener('DOMContentLoaded', passwd_checker);
} else {  // `DOMContentLoaded` has already fired
  passwd_checker();
}
